/* Author :shilei
   Date :shilei
   Department:Fusion location Lab.

*/
#include "PSINS.h"
#include "KFApp.h"
#include "sinsapi.h"

#define FreqOut 50   //qidi
#define Freq_imu 50 //qidi 50Hz imu,
#define Freq_imu2 0.5*Freq_imu //50%*Freq_imu
#define SaveRawdata 0
#define INS_time 15 //ߵʱ䳤

#define Reget_satelite 4//ػ2s ʼʾں϶λ
#define Std_static_acc0 0.25//Ծֹqidi
#define Std_static_acc2 0.3//ɾֹ
#define Std_static_gyr0 0.12//Ծֹ
#define Std_static_gyr2 0.2//ɾֹ
#define Tempreture_comp 0 // ¶Ȳ

// 822
#ifdef WIN32
CFileRdWt dir("C:\\F\\SINS-GNSS\\Yan_PSINS_Program\\PSINS-CPP-VC60(qidi)\\PSINS-CPP\\Data\\");
CFileRdWt  fins("ins.bin", 0), fkf("kf.bin", 0), frk("rk.bin", 0);// realtime Ҫ
#endif

int reget_sateliti_count = 0;
int imu_cnt = 0;
int OutCount = 1;//Ƶʿ
double Ts = 1.0 / Freq_imu;
double ggatime = 0.0;
double timu_m = 0.0;
bool KfInit = false;
bool count1KfInit = true;
bool install_init = false;
bool imu_instal = false;
bool imu_static = false;
bool lose_kfsetmeant = false;

typedef struct {
	double ax[50], ay[50], az[50], gx[50], gy[50], gz[50];
	double stdimu[4];
	double install_acc[3];
	CVect3 att_install;
}ImuAvr_t;


CVect3 wm, vm, att, att_static, gpsvn, gpspos, eb0, eb1;
MPU_Data_value mpu_data;
Out_Data sins_out;
ImuAvr_t imuavr;
CKFApp kf;

double GetAveStdRMS(const double *a, int n, int opt)
{
	int i;
	double avg = 0.0, std = 0.0, rms = 0.0, sum = 0.0;

	if (n == 0) return 99999.9;

	for (i = 0; i < n; i++) {
		sum += a[i];
		rms += a[i] * a[i];
	}
	avg = sum / n;

	if (opt == 0)
		return avg;

	sum = 0.0;
	for (i = 0; i < n; i++) {
		sum += (a[i] - avg)*(a[i] - avg);
	}

	std = sqrt(sum / double(n - 1));
	rms = sqrt(rms / double(n));

	if (opt == 1)
		return std;
	else if (opt == 2)
		return rms;

	return 0.0;
}

//ݵλϵҪͽӿ˵һ dpsgenu
Out_Data* SINS_API(MPU_Data_value *mpu_Data_value, gga_t *gga, vtg_t *vtg, dhv_t *dhv, double gga_delay, int gps_ok_flag)
{
	Out_Data * p_sins_out = NULL;
	double acc[3] = { 0.0 };
	double gyro[3] = { 0.0 };
	double temp_m;
	/********************************             IMU   update          **************************************************/
	// ¶ȲƯ
#if 0
	if (Tempreture_comp)
	{
		temp_m  = mpu_Data_value->Temp;
		gyro[0] = mpu_Data_value->Gyro[0];//y>>X_car
		gyro[1] = mpu_Data_value->Gyro[1];//x>>Y_car
		gyro[2] = mpu_Data_value->Gyro[2];//-z>>Z_car	
		if (temp_m<50.0&&temp_m>30.0)
		{
			gyro[0] = gyro[0] +(-0.008263636*temp_m+0.7575);
			gyro[1] = gyro[1] +(0.042663636*temp_m-0.639145455);
			gyro[2] = gyro[2] +(0.000281818*temp_m+0.261236364);
		}
	}
#endif
	wm = *(CVect3*)mpu_Data_value->Gyro;//dps //ENU 
	vm = *(CVect3*)mpu_Data_value->Accel;//m/s2
	//ۼAPI
	imuavr.ax[imu_cnt] = vm.i;//ENU ϵ
	imuavr.ay[imu_cnt] = vm.j;
	imuavr.az[imu_cnt] = vm.k;
	imuavr.gx[imu_cnt] = wm.i;
	imuavr.gy[imu_cnt] = wm.j;
	imuavr.gz[imu_cnt] = wm.k;
	imu_cnt++;
	timu_m = mpu_Data_value->time;
	if (imu_instal)//ʧ׼Ƿɹ
	{
		CMat3 Cnb_install;
		Cnb_install = a2mat(imuavr.att_install);
		wm = Cnb_install * (wm - eb0);//ƽȥbias  dps
		vm = Cnb_install * vm;// ٶm/s2
	}
	if (imu_cnt == Freq_imu)//0.5s 
	{
		imuavr.stdimu[0] = GetAveStdRMS(imuavr.ax, Freq_imu, 1);
		imuavr.stdimu[1] = GetAveStdRMS(imuavr.ay, Freq_imu, 1);
		imuavr.stdimu[2] = GetAveStdRMS(imuavr.az, Freq_imu, 1);
		imuavr.stdimu[3] = GetAveStdRMS(imuavr.gz, Freq_imu, 1);
		imu_cnt = 0;
		if (imuavr.stdimu[0] < Std_static_acc2&&imuavr.stdimu[1] < Std_static_acc2&&imuavr.stdimu[3] < Std_static_gyr2)//¾ֹ
		{
			if (!imu_instal)
			{
				eb0.i = GetAveStdRMS(imuavr.gx, Freq_imu, 0);//biasֵ
				eb0.j = GetAveStdRMS(imuavr.gy, Freq_imu, 0);
				eb0.k = GetAveStdRMS(imuavr.gz, Freq_imu, 0);

				imuavr.install_acc[0] = GetAveStdRMS(imuavr.ax, 50, 0);
				imuavr.install_acc[1] = GetAveStdRMS(imuavr.ay, 50, 0);
				imuavr.install_acc[2] = GetAveStdRMS(imuavr.az, 50, 0);
				double gyz = sqrt(imuavr.install_acc[1] * imuavr.install_acc[1] + imuavr.install_acc[2] * imuavr.install_acc[2]);
			
				// install roll pitch
				imuavr.att_install.j = -1.0*atan(imuavr.install_acc[0] / gyz);//roll ,rad
				imuavr.att_install.i = atan(imuavr.install_acc[1] / imuavr.install_acc[2]);//pitch ,rad
				imuavr.att_install.k = 0.0;
				imu_instal = true;//װʼж
				//printf(" qidi install ok \r\n");
			}
			imu_static = true;//̬ж
		}
		else
		{
			imu_static = false;
		}
#if 0
//if (imuavr.stdimu[0] < Std_static_acc0&&imuavr.stdimu[1] < Std_static_acc0&&imuavr.stdimu[3] < Std_static_gyr0)//imu ax ay az gz Ծֹ
		{
			//eb1.i = GetAveStdRMS(imuavr.gx, Freq_imu, 0);//biasֵ
			//eb1.j = GetAveStdRMS(imuavr.gy, Freq_imu, 0);
			//eb1.k = GetAveStdRMS(imuavr.gz, Freq_imu, 0);
			////if (timu_m>304)
			{
				//eb0.i = eb1.i - kf.sins.eb.i / glv.deg;
				//eb0.j = eb1.j - kf.sins.eb.j / glv.deg;
				//eb0.k = eb1.k - kf.sins.eb.k / glv.deg;

				//imuavr.install_acc[0] = GetAveStdRMS(imuavr.ax, 50, 0) - kf.sins.db.i;
				//imuavr.install_acc[1] = GetAveStdRMS(imuavr.ay, 50, 0) - kf.sins.db.j;
				//imuavr.install_acc[2] = GetAveStdRMS(imuavr.az, 50, 0) - kf.sins.db.k;
				//double gyz = sqrt(imuavr.install_acc[1] * imuavr.install_acc[1] + imuavr.install_acc[2] * imuavr.install_acc[2]);
				//˴ ԿŻٶϵӦϱϵ
				// install roll pitch

				//kf.sins.vn = 0.0;//ٶȶ

				//att_static.j = -1.0*atan(imuavr.install_acc[0] / gyz) - imuavr.att_install.j;//roll ,rad
				//att_static.i = atan(imuavr.install_acc[1] / imuavr.install_acc[2]) - imuavr.att_install.i;//pitch ,rad
				//att_static.k = kf.sins.att.k;
				//kf.sins.qnb = a2qua(att_static);//̬ʱ̬У
				//CMat3 Cnb_install;
				////Cnb_install = a2mat(imuavr.att_install);
				//Cnb_install = a2mat(att_static);
				//CVect3 acc, vmm;
				//acc = *(CVect3*)imuavr.install_acc;
				//vmm = Cnb_install * acc;
			}
		}//==25
#endif
	}//imu install anglegyro eb

	wm = wm * glv.dps*Ts; vm = vm * Ts;// λ rad m/s

	/********************************         GNSS  update                  **************************************************/

	if (gps_ok_flag)//˴ λ
	{
		gpspos.i = (gga->lat_d + gga->lat_m / 60.0)*glv.deg;//õradγ  ߳
		gpspos.j = (gga->lon_d + gga->lon_m / 60.0)*glv.deg;
		gpspos.k = gga->altitude;

		gpsvn.i = dhv->vel_e;//venu  
		gpsvn.j = dhv->vel_n;//Nٶ m/s
		gpsvn.k = dhv->vel_u;//Uٶ

		if (count1KfInit && norm(gpsvn) > 3.0&& gga->num_satellite > 4 && gga->h_DOP < 5.0)// KF ʼ
		{
			double yaw0 = 0.0;
			yaw0 = -atan2(gpsvn.i, gpsvn.j) / glv.deg;//deg
			kf.Init16(CSINS(a2qua(CVect3(0.0, 0.0, yaw0)*glv.deg), gpsvn, gpspos, timu_m));  // ʼ̬λλ 0.0ʱ
			KfInit = true;
			count1KfInit = false;
			//printf("sins kf.Init16  imutime %.3lf\r\n", mpu_Data_value->time);
		}

		if (KfInit&& gga->num_satellite > 5 && gga->h_DOP < 5.0)
		{
			//if (gga->fix == 4 || gga->fix == 5)	// Rֵ
			kf.SetMeas(&gpsvn, &gpspos, gga_delay);// gga_delay ggaӳʱ
			ggatime = mpu_Data_value->time;//Чλʱ 
		
			reget_sateliti_count++;//ػǿʼ

			//if (norm(gpsvn) > 10.0&&gga->h_DOP < 5.0&&gga->num_satellite>4)// ǿԼ
			//{kf.sins.att.k = -atan2(gpsvn.i, gpsvn.j);//ǿԼ˺ʧ׼
			//	kf.sins.qnb = a2qua(kf.sins.att);}
		}
	}//gps_ok_flag
	if (KfInit)
	{

		kf.Update(&wm, &vm, 1, Ts);//KF 


#ifdef WIN32
		if ((timu_m - ggatime) < INS_time)// &&reget_sateliti_count > Reget_satelite)  //ʧ10sλػ3sλ
		//if (KfInit && (timu_m - ggatime) < INS_time && (OutCount >= Freq_imu / FreqOut + 1) && reget_sateliti_count > Reget_satelite)
		{
			CSINS sins_sl = kf.sins;

			fins << kf.sins;
			fkf << kf;
			fins << kf.sins;
			frk << kf.Rt;
			//printf("timu_m - ggatime %f\r\n", timu_m - ggatime);
		}
#endif
		if ((timu_m - ggatime)>1.5)
		{
			//ٶ·ֽ//sl 925 yaw0 = -atan2(gpsvn.i, gpsvn.j) / glv.deg;//deg
			double anij = sqrt(kf.sins.an.i*kf.sins.an.i + kf.sins.an.j*kf.sins.an.j);
			kf.sins.an.i = anij * sin(-kf.sins.att.k);
			kf.sins.an.j = anij * cos(-kf.sins.att.k);
			double vnij = sqrt(kf.sins.vn.i*kf.sins.vn.i + kf.sins.vn.j*kf.sins.vn.j);
			kf.sins.vn.i = anij * sin(-kf.sins.att.k);
			kf.sins.vn.j = anij * cos(-kf.sins.att.k);
		}
		if ((timu_m - ggatime) > INS_time)
		{
			reget_sateliti_count = 0;
		}

		if (norm(kf.sins.vn) > 40.0)//ֹͣߵ
		{
			kf.sins.vn.i = gpsvn.i;
			kf.sins.vn.j = gpsvn.j;
			kf.sins.vn.k = gpsvn.k;
			//KfInit = false;
			//count1KfInit = true;
		}
		if (timu_m - ggatime > 120.0)//2minʧҪֹͣߵ 
		{
			KfInit = false;
			count1KfInit = true;
		}
	}
	//λ
	if (KfInit && (timu_m - ggatime) < INS_time&&(OutCount >=Freq_imu/FreqOut+1)&& reget_sateliti_count> Reget_satelite)//
	{
		CVect3 att;
		att = q2att(kf.sins.qnb);
		sins_out.Att[0] = att.i / glv.deg;
		sins_out.Att[1] = att.j / glv.deg;
		sins_out.Att[2] = CC180toC360(att.k) / glv.deg;
		sins_out.Vn[0] = kf.sins.vn.i;
		sins_out.Vn[1] = kf.sins.vn.j;
		sins_out.Vn[2] = kf.sins.vn.k;
		int deg;
		deg = kf.sins.pos.j / glv.deg;//γ
		sins_out.Pos[0] = deg;
		sins_out.Pos[1] = kf.sins.pos.j / glv.deg - deg;//γС
		deg = kf.sins.pos.i / glv.deg;
		sins_out.Pos[2] = deg;
		sins_out.Pos[3] = kf.sins.pos.i / glv.deg - deg;
		sins_out.Pos[4] = kf.sins.pos.k;//	
		sins_out.GPS_status = gga->fix;
		sins_out.timestamp = gga->sec + timu_m - ggatime;	// ߵλʱ  gga +insʱ
		if((timu_m - ggatime)>1.3) sins_out.GPS_status = 6;
		p_sins_out = &sins_out;
		OutCount = 1;
	}
	OutCount++;
	return p_sins_out;//kf δʼģ鶨λNULL ָ
}//SINS_API

